diff --git a/orocos_kdl/src/framevel.hpp b/orocos_kdl/src/framevel.hpp
index 1310a10..b1c74f3 100644
--- a/orocos_kdl/src/framevel.hpp
+++ b/orocos_kdl/src/framevel.hpp
@@ -28,26 +28,25 @@
 #include "utilities/traits.h"
 
 #include "frames.hpp"
-
-
+#include "kdl_export.hpp"
 
 namespace KDL {
 
 typedef Rall1d<double> doubleVel;
 
-IMETHOD doubleVel diff(const doubleVel& a,const doubleVel& b,double dt=1.0) {
+KDL_EXPORT IMETHOD doubleVel diff(const doubleVel& a,const doubleVel& b,double dt=1.0) {
 	return doubleVel((b.t-a.t)/dt,(b.grad-a.grad)/dt);
 }
 
-IMETHOD doubleVel addDelta(const doubleVel& a,const doubleVel&da,double dt=1.0) {
+KDL_EXPORT IMETHOD doubleVel addDelta(const doubleVel& a,const doubleVel&da,double dt=1.0) {
 	return doubleVel(a.t+da.t*dt,a.grad+da.grad*dt);
 }
 
-IMETHOD void random(doubleVel& F) {
+KDL_EXPORT IMETHOD void random(doubleVel& F) {
 	random(F.t);
 	random(F.grad);
 }
-IMETHOD void posrandom(doubleVel& F) {
+KDL_EXPORT IMETHOD void posrandom(doubleVel& F) {
 	posrandom(F.t);
 	posrandom(F.grad);
 }
@@ -67,7 +66,7 @@ class VectorVel;
 class FrameVel;
 class RotationVel;
 
-class VectorVel
+class KDL_EXPORT VectorVel
 // = TITLE
 //     An VectorVel is a Vector and its first derivative
 // = CLASS TYPE
@@ -91,38 +90,38 @@ public:
     IMETHOD static VectorVel Zero();
     IMETHOD void ReverseSign();
     IMETHOD doubleVel Norm() const;
-    IMETHOD friend VectorVel operator + (const VectorVel& r1,const VectorVel& r2);
-    IMETHOD friend VectorVel operator - (const VectorVel& r1,const VectorVel& r2);
-    IMETHOD friend VectorVel operator + (const Vector& r1,const VectorVel& r2);
-    IMETHOD friend VectorVel operator - (const Vector& r1,const VectorVel& r2);
-    IMETHOD friend VectorVel operator + (const VectorVel& r1,const Vector& r2);
-    IMETHOD friend VectorVel operator - (const VectorVel& r1,const Vector& r2);
-    IMETHOD friend VectorVel operator * (const VectorVel& r1,const VectorVel& r2);
-    IMETHOD friend VectorVel operator * (const VectorVel& r1,const Vector& r2);
-    IMETHOD friend VectorVel operator * (const Vector& r1,const VectorVel& r2);
-    IMETHOD friend VectorVel operator * (const VectorVel& r1,double r2);
-    IMETHOD friend VectorVel operator * (double r1,const VectorVel& r2);
-    IMETHOD friend VectorVel operator * (const doubleVel& r1,const VectorVel& r2);
-    IMETHOD friend VectorVel operator * (const VectorVel& r2,const doubleVel& r1);
-    IMETHOD friend VectorVel operator*(const Rotation& R,const VectorVel& x);
-
-    IMETHOD friend VectorVel operator / (const VectorVel& r1,double r2);
-    IMETHOD friend VectorVel operator / (const VectorVel& r2,const doubleVel& r1);
-    IMETHOD friend void SetToZero(VectorVel& v);
-
-
-    IMETHOD friend bool Equal(const VectorVel& r1,const VectorVel& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const Vector& r1,const VectorVel& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const VectorVel& r1,const Vector& r2,double eps=epsilon);
-    IMETHOD friend VectorVel operator - (const VectorVel& r);
-    IMETHOD friend doubleVel dot(const VectorVel& lhs,const VectorVel& rhs);
-    IMETHOD friend doubleVel dot(const VectorVel& lhs,const Vector& rhs);
-    IMETHOD friend doubleVel dot(const Vector& lhs,const VectorVel& rhs);
+    KDL_EXPORT IMETHOD friend VectorVel operator + (const VectorVel& r1,const VectorVel& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator - (const VectorVel& r1,const VectorVel& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator + (const Vector& r1,const VectorVel& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator - (const Vector& r1,const VectorVel& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator + (const VectorVel& r1,const Vector& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator - (const VectorVel& r1,const Vector& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator * (const VectorVel& r1,const VectorVel& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator * (const VectorVel& r1,const Vector& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator * (const Vector& r1,const VectorVel& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator * (const VectorVel& r1,double r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator * (double r1,const VectorVel& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator * (const doubleVel& r1,const VectorVel& r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator * (const VectorVel& r2,const doubleVel& r1);
+    KDL_EXPORT IMETHOD friend VectorVel operator*(const Rotation& R,const VectorVel& x);
+
+    KDL_EXPORT IMETHOD friend VectorVel operator / (const VectorVel& r1,double r2);
+    KDL_EXPORT IMETHOD friend VectorVel operator / (const VectorVel& r2,const doubleVel& r1);
+    KDL_EXPORT IMETHOD friend void SetToZero(VectorVel& v);
+
+
+    KDL_EXPORT IMETHOD friend bool Equal(const VectorVel& r1,const VectorVel& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const Vector& r1,const VectorVel& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const VectorVel& r1,const Vector& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend VectorVel operator - (const VectorVel& r);
+    KDL_EXPORT IMETHOD friend doubleVel dot(const VectorVel& lhs,const VectorVel& rhs);
+    KDL_EXPORT IMETHOD friend doubleVel dot(const VectorVel& lhs,const Vector& rhs);
+    KDL_EXPORT IMETHOD friend doubleVel dot(const Vector& lhs,const VectorVel& rhs);
 };
 
 
 
-class RotationVel
+class KDL_EXPORT RotationVel
 // = TITLE
 //     An RotationVel is a Rotation and its first derivative, a rotation vector
 // = CLASS TYPE
@@ -164,12 +163,12 @@ public:
     IMETHOD static RotationVel Rot2(const Vector& rotvec,const doubleVel& angle);
     // rotvec is normalized.
     // rotation around a constant vector !
-    IMETHOD friend RotationVel operator* (const RotationVel& r1,const RotationVel& r2);
-    IMETHOD friend RotationVel operator* (const Rotation& r1,const RotationVel& r2);
-    IMETHOD friend RotationVel operator* (const RotationVel& r1,const Rotation& r2);
-    IMETHOD friend bool Equal(const RotationVel& r1,const RotationVel& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const Rotation& r1,const RotationVel& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const RotationVel& r1,const Rotation& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend RotationVel operator* (const RotationVel& r1,const RotationVel& r2);
+    KDL_EXPORT IMETHOD friend RotationVel operator* (const Rotation& r1,const RotationVel& r2);
+    KDL_EXPORT IMETHOD friend RotationVel operator* (const RotationVel& r1,const Rotation& r2);
+    KDL_EXPORT IMETHOD friend bool Equal(const RotationVel& r1,const RotationVel& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const Rotation& r1,const RotationVel& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const RotationVel& r1,const Rotation& r2,double eps=epsilon);
 
     IMETHOD TwistVel Inverse(const TwistVel& arg) const;
     IMETHOD TwistVel Inverse(const Twist& arg) const;
@@ -180,7 +179,7 @@ public:
 
 
 
-class FrameVel
+class KDL_EXPORT FrameVel
 // = TITLE
 //     An FrameVel is a Frame and its first derivative, a Twist vector
 // = CLASS TYPE
@@ -218,12 +217,12 @@ public:
     IMETHOD VectorVel Inverse(const Vector& arg) const;
     IMETHOD Frame GetFrame() const;
     IMETHOD Twist GetTwist() const;
-    IMETHOD friend FrameVel operator * (const FrameVel& f1,const FrameVel& f2);
-    IMETHOD friend FrameVel operator * (const Frame& f1,const FrameVel& f2);
-    IMETHOD friend FrameVel operator * (const FrameVel& f1,const Frame& f2);
-    IMETHOD friend bool Equal(const FrameVel& r1,const FrameVel& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const Frame& r1,const FrameVel& r2,double eps=epsilon);
-    IMETHOD friend bool Equal(const FrameVel& r1,const Frame& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend FrameVel operator * (const FrameVel& f1,const FrameVel& f2);
+    KDL_EXPORT IMETHOD friend FrameVel operator * (const Frame& f1,const FrameVel& f2);
+    KDL_EXPORT IMETHOD friend FrameVel operator * (const FrameVel& f1,const Frame& f2);
+    KDL_EXPORT IMETHOD friend bool Equal(const FrameVel& r1,const FrameVel& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const Frame& r1,const FrameVel& r2,double eps=epsilon);
+    KDL_EXPORT IMETHOD friend bool Equal(const FrameVel& r1,const Frame& r2,double eps=epsilon);
 
     IMETHOD TwistVel  Inverse(const TwistVel& arg) const;
     IMETHOD TwistVel  Inverse(const Twist& arg) const;
@@ -236,7 +235,7 @@ public:
 
 
 //very similar to Wrench class.
-class TwistVel
+class KDL_EXPORT TwistVel
 // = TITLE
 // This class represents a TwistVel. This is a velocity and rotational velocity together
 {
@@ -262,18 +261,18 @@ public:
      IMETHOD TwistVel& operator+=(const TwistVel& arg);
 
 // = External operators
-     IMETHOD friend TwistVel operator*(const TwistVel& lhs,double rhs);
-     IMETHOD friend TwistVel operator*(double lhs,const TwistVel& rhs);
-     IMETHOD friend TwistVel operator/(const TwistVel& lhs,double rhs);
+     KDL_EXPORT IMETHOD friend TwistVel operator*(const TwistVel& lhs,double rhs);
+     KDL_EXPORT IMETHOD friend TwistVel operator*(double lhs,const TwistVel& rhs);
+     KDL_EXPORT IMETHOD friend TwistVel operator/(const TwistVel& lhs,double rhs);
 
-     IMETHOD friend TwistVel operator*(const TwistVel& lhs,const doubleVel& rhs);
-     IMETHOD friend TwistVel operator*(const doubleVel& lhs,const TwistVel& rhs);
-     IMETHOD friend TwistVel operator/(const TwistVel& lhs,const doubleVel& rhs);
+     KDL_EXPORT IMETHOD friend TwistVel operator*(const TwistVel& lhs,const doubleVel& rhs);
+     KDL_EXPORT IMETHOD friend TwistVel operator*(const doubleVel& lhs,const TwistVel& rhs);
+     KDL_EXPORT IMETHOD friend TwistVel operator/(const TwistVel& lhs,const doubleVel& rhs);
 
-     IMETHOD friend TwistVel operator+(const TwistVel& lhs,const TwistVel& rhs);
-     IMETHOD friend TwistVel operator-(const TwistVel& lhs,const TwistVel& rhs);
-     IMETHOD friend TwistVel operator-(const TwistVel& arg);
-     IMETHOD friend void SetToZero(TwistVel& v);
+     KDL_EXPORT IMETHOD friend TwistVel operator+(const TwistVel& lhs,const TwistVel& rhs);
+     KDL_EXPORT IMETHOD friend TwistVel operator-(const TwistVel& lhs,const TwistVel& rhs);
+     KDL_EXPORT IMETHOD friend TwistVel operator-(const TwistVel& arg);
+     KDL_EXPORT IMETHOD friend void SetToZero(TwistVel& v);
 
 
 // = Zero
@@ -293,9 +292,9 @@ public:
      // = Equality operators
      // do not use operator == because the definition of Equal(.,.) is slightly
      // different.  It compares whether the 2 arguments are equal in an eps-interval
-     IMETHOD friend bool Equal(const TwistVel& a,const TwistVel& b,double eps=epsilon);
-     IMETHOD friend bool Equal(const Twist& a,const TwistVel& b,double eps=epsilon);
-     IMETHOD friend bool Equal(const TwistVel& a,const Twist& b,double eps=epsilon);
+     KDL_EXPORT IMETHOD friend bool Equal(const TwistVel& a,const TwistVel& b,double eps=epsilon);
+     KDL_EXPORT IMETHOD friend bool Equal(const Twist& a,const TwistVel& b,double eps=epsilon);
+     KDL_EXPORT IMETHOD friend bool Equal(const TwistVel& a,const Twist& b,double eps=epsilon);
 
 // = Conversion to other entities
      IMETHOD Twist GetTwist() const;
@@ -306,65 +305,65 @@ public:
 
 };
 
-IMETHOD VectorVel diff(const VectorVel& a,const VectorVel& b,double dt=1.0) {
+KDL_EXPORT IMETHOD VectorVel diff(const VectorVel& a,const VectorVel& b,double dt=1.0) {
 	return VectorVel(diff(a.p,b.p,dt),diff(a.v,b.v,dt));
 }
 
-IMETHOD VectorVel addDelta(const VectorVel& a,const VectorVel&da,double dt=1.0) {
+KDL_EXPORT IMETHOD VectorVel addDelta(const VectorVel& a,const VectorVel&da,double dt=1.0) {
 	return VectorVel(addDelta(a.p,da.p,dt),addDelta(a.v,da.v,dt));
 }
-IMETHOD VectorVel diff(const RotationVel& a,const RotationVel& b,double dt = 1.0) {
+KDL_EXPORT IMETHOD VectorVel diff(const RotationVel& a,const RotationVel& b,double dt = 1.0) {
 	return VectorVel(diff(a.R,b.R,dt),diff(a.w,b.w,dt));
 }
 
-IMETHOD RotationVel addDelta(const RotationVel& a,const VectorVel&da,double dt=1.0) {
+KDL_EXPORT IMETHOD RotationVel addDelta(const RotationVel& a,const VectorVel&da,double dt=1.0) {
 	return RotationVel(addDelta(a.R,da.p,dt),addDelta(a.w,da.v,dt));
 }
 
-IMETHOD TwistVel diff(const FrameVel& a,const FrameVel& b,double dt=1.0) {
+KDL_EXPORT IMETHOD TwistVel diff(const FrameVel& a,const FrameVel& b,double dt=1.0) {
 	return TwistVel(diff(a.M,b.M,dt),diff(a.p,b.p,dt));
 }
 
-IMETHOD FrameVel addDelta(const FrameVel& a,const TwistVel& da,double dt=1.0) {
+KDL_EXPORT IMETHOD FrameVel addDelta(const FrameVel& a,const TwistVel& da,double dt=1.0) {
 	return FrameVel(
 			addDelta(a.M,da.rot,dt),
 			addDelta(a.p,da.vel,dt)
 		   );
 }
 
-IMETHOD void random(VectorVel& a) {
+KDL_EXPORT IMETHOD void random(VectorVel& a) {
 	random(a.p);
 	random(a.v);
 }
-IMETHOD void random(TwistVel& a) {
+KDL_EXPORT IMETHOD void random(TwistVel& a) {
 	random(a.vel);
 	random(a.rot);
 }
 
-IMETHOD void random(RotationVel& R) {
+KDL_EXPORT IMETHOD void random(RotationVel& R) {
 	random(R.R);
 	random(R.w);
 }
 
-IMETHOD void random(FrameVel& F) {
+KDL_EXPORT IMETHOD void random(FrameVel& F) {
 	random(F.M);
 	random(F.p);
 }
-IMETHOD void posrandom(VectorVel& a) {
+KDL_EXPORT IMETHOD void posrandom(VectorVel& a) {
 	posrandom(a.p);
 	posrandom(a.v);
 }
-IMETHOD void posrandom(TwistVel& a) {
+KDL_EXPORT IMETHOD void posrandom(TwistVel& a) {
 	posrandom(a.vel);
 	posrandom(a.rot);
 }
 
-IMETHOD void posrandom(RotationVel& R) {
+KDL_EXPORT IMETHOD void posrandom(RotationVel& R) {
 	posrandom(R.R);
 	posrandom(R.w);
 }
 
-IMETHOD void posrandom(FrameVel& F) {
+KDL_EXPORT IMETHOD void posrandom(FrameVel& F) {
 	posrandom(F.M);
 	posrandom(F.p);
 }
diff --git a/orocos_kdl/src/framevel_io.hpp b/orocos_kdl/src/framevel_io.hpp
index 2124c13..0cbb87e 100644
--- a/orocos_kdl/src/framevel_io.hpp
+++ b/orocos_kdl/src/framevel_io.hpp
@@ -23,27 +23,28 @@
 
 #include "framevel_io.hpp"
 #include "frames_io.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL {
 
 // Output...
-inline std::ostream& operator << (std::ostream& os,const VectorVel& r) {
+KDL_EXPORT inline std::ostream& operator << (std::ostream& os,const VectorVel& r) {
     os << "{" << r.p << "," << r.v << "}" << std::endl;
     return os;
 }
 
-inline std::ostream& operator << (std::ostream& os,const RotationVel& r) {
+KDL_EXPORT inline std::ostream& operator << (std::ostream& os,const RotationVel& r) {
     os << "{" << std::endl << r.R << "," <<std::endl << r.w << std::endl << "}" << std::endl;
     return os;
 }
 
 
-inline std::ostream& operator << (std::ostream& os,const FrameVel& r) {
+KDL_EXPORT inline std::ostream& operator << (std::ostream& os,const FrameVel& r) {
     os << "{" << std::endl << r.M << "," << std::endl << r.p << std::endl << "}" << std::endl;
     return os;
 }
 
-inline std::ostream& operator << (std::ostream& os,const TwistVel& r) {
+KDL_EXPORT inline std::ostream& operator << (std::ostream& os,const TwistVel& r) {
     os << "{" << std::endl << r.vel << "," << std::endl << r.rot << std::endl << "}" << std::endl;
     return os;
 }
diff --git a/orocos_kdl/src/jacobian.hpp b/orocos_kdl/src/jacobian.hpp
index 4225ef8..ca7a596 100644
--- a/orocos_kdl/src/jacobian.hpp
+++ b/orocos_kdl/src/jacobian.hpp
@@ -23,11 +23,12 @@
 #define KDL_JACOBIAN_HPP
 
 #include "frames.hpp"
+#include "kdl_export.hpp"
 #include <Eigen/Core>
 
 namespace KDL
 {
-    class Jacobian
+    class KDL_EXPORT Jacobian
     {
     public:
         Eigen::Matrix<double,6,Eigen::Dynamic> data;
@@ -44,7 +45,7 @@ namespace KDL
         bool operator ==(const Jacobian& arg)const;
         bool operator !=(const Jacobian& arg)const;
         
-        friend bool Equal(const Jacobian& a,const Jacobian& b,double eps=epsilon);
+        KDL_EXPORT friend bool Equal(const Jacobian& a,const Jacobian& b,double eps=epsilon);
         
 
         ~Jacobian();
@@ -54,11 +55,11 @@ namespace KDL
         unsigned int rows()const;
         unsigned int columns()const;
 
-        friend void SetToZero(Jacobian& jac);
+        KDL_EXPORT friend void SetToZero(Jacobian& jac);
 
-        friend bool changeRefPoint(const Jacobian& src1, const Vector& base_AB, Jacobian& dest);
-        friend bool changeBase(const Jacobian& src1, const Rotation& rot, Jacobian& dest);
-        friend bool changeRefFrame(const Jacobian& src1,const Frame& frame, Jacobian& dest);
+        KDL_EXPORT friend bool changeRefPoint(const Jacobian& src1, const Vector& base_AB, Jacobian& dest);
+        KDL_EXPORT friend bool changeBase(const Jacobian& src1, const Rotation& rot, Jacobian& dest);
+        KDL_EXPORT friend bool changeRefFrame(const Jacobian& src1,const Frame& frame, Jacobian& dest);
 
         Twist getColumn(unsigned int i) const;
         void setColumn(unsigned int i,const Twist& t);
diff --git a/orocos_kdl/src/jntarray.hpp b/orocos_kdl/src/jntarray.hpp
index c438a67..c026375 100644
--- a/orocos_kdl/src/jntarray.hpp
+++ b/orocos_kdl/src/jntarray.hpp
@@ -24,6 +24,7 @@
 
 #include "frames.hpp"
 #include "jacobian.hpp"
+#include "kdl_export.hpp"
 
 #include <Eigen/Core>
 
@@ -66,7 +67,7 @@ class MyTask : public RTT::TaskContext
 
      */	
 
-    class JntArray
+    class KDL_EXPORT JntArray
     {
     public:
         Eigen::VectorXd data;
@@ -135,15 +136,15 @@ class MyTask : public RTT::TaskContext
          */
         unsigned int columns()const;
 
-        friend void Add(const JntArray& src1,const JntArray& src2,JntArray& dest);
-        friend void Subtract(const JntArray& src1,const JntArray& src2,JntArray& dest);
-        friend void Multiply(const JntArray& src,const double& factor,JntArray& dest);
-        friend void Divide(const JntArray& src,const double& factor,JntArray& dest);
-        friend void MultiplyJacobian(const Jacobian& jac, const JntArray& src, Twist& dest);
-        friend void SetToZero(JntArray& array);
-        friend bool Equal(const JntArray& src1,const JntArray& src2,double eps);
+        KDL_EXPORT friend void Add(const JntArray& src1,const JntArray& src2,JntArray& dest);
+        KDL_EXPORT friend void Subtract(const JntArray& src1,const JntArray& src2,JntArray& dest);
+        KDL_EXPORT friend void Multiply(const JntArray& src,const double& factor,JntArray& dest);
+        KDL_EXPORT friend void Divide(const JntArray& src,const double& factor,JntArray& dest);
+        KDL_EXPORT friend void MultiplyJacobian(const Jacobian& jac, const JntArray& src, Twist& dest);
+        KDL_EXPORT friend void SetToZero(JntArray& array);
+        KDL_EXPORT friend bool Equal(const JntArray& src1,const JntArray& src2,double eps);
 
-        friend bool operator==(const JntArray& src1,const JntArray& src2);
+        KDL_EXPORT friend bool operator==(const JntArray& src1,const JntArray& src2);
         //friend bool operator!=(const JntArray& src1,const JntArray& src2);
         };
 
diff --git a/orocos_kdl/src/jntarrayacc.hpp b/orocos_kdl/src/jntarrayacc.hpp
index c3d929e..5d0ce29 100644
--- a/orocos_kdl/src/jntarrayacc.hpp
+++ b/orocos_kdl/src/jntarrayacc.hpp
@@ -26,10 +26,11 @@
 #include "jntarray.hpp"
 #include "jntarrayvel.hpp"
 #include "frameacc.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL
 {
-    class JntArrayAcc
+    class KDL_EXPORT JntArrayAcc
     {
     public:
         JntArray q;
@@ -48,20 +49,20 @@ namespace KDL
         JntArray deriv()const;
         JntArray dderiv()const;
 
-        friend void Add(const JntArrayAcc& src1,const JntArrayAcc& src2,JntArrayAcc& dest);
-        friend void Add(const JntArrayAcc& src1,const JntArrayVel& src2,JntArrayAcc& dest);
-        friend void Add(const JntArrayAcc& src1,const JntArray& src2,JntArrayAcc& dest);
-        friend void Subtract(const JntArrayAcc& src1,const JntArrayAcc& src2,JntArrayAcc& dest);
-        friend void Subtract(const JntArrayAcc& src1,const JntArrayVel& src2,JntArrayAcc& dest);
-        friend void Subtract(const JntArrayAcc& src1,const JntArray& src2,JntArrayAcc& dest);
-        friend void Multiply(const JntArrayAcc& src,const double& factor,JntArrayAcc& dest);
-        friend void Multiply(const JntArrayAcc& src,const doubleVel& factor,JntArrayAcc& dest);
-        friend void Multiply(const JntArrayAcc& src,const doubleAcc& factor,JntArrayAcc& dest);
-        friend void Divide(const JntArrayAcc& src,const double& factor,JntArrayAcc& dest);
-        friend void Divide(const JntArrayAcc& src,const doubleVel& factor,JntArrayAcc& dest);
-        friend void Divide(const JntArrayAcc& src,const doubleAcc& factor,JntArrayAcc& dest);
-        friend void SetToZero(JntArrayAcc& array);
-        friend bool Equal(const JntArrayAcc& src1,const JntArrayAcc& src2,double eps=epsilon);
+        KDL_EXPORT friend void Add(const JntArrayAcc& src1,const JntArrayAcc& src2,JntArrayAcc& dest);
+        KDL_EXPORT friend void Add(const JntArrayAcc& src1,const JntArrayVel& src2,JntArrayAcc& dest);
+        KDL_EXPORT friend void Add(const JntArrayAcc& src1,const JntArray& src2,JntArrayAcc& dest);
+        KDL_EXPORT friend void Subtract(const JntArrayAcc& src1,const JntArrayAcc& src2,JntArrayAcc& dest);
+        KDL_EXPORT friend void Subtract(const JntArrayAcc& src1,const JntArrayVel& src2,JntArrayAcc& dest);
+        KDL_EXPORT friend void Subtract(const JntArrayAcc& src1,const JntArray& src2,JntArrayAcc& dest);
+        KDL_EXPORT friend void Multiply(const JntArrayAcc& src,const double& factor,JntArrayAcc& dest);
+        KDL_EXPORT friend void Multiply(const JntArrayAcc& src,const doubleVel& factor,JntArrayAcc& dest);
+        KDL_EXPORT friend void Multiply(const JntArrayAcc& src,const doubleAcc& factor,JntArrayAcc& dest);
+        KDL_EXPORT friend void Divide(const JntArrayAcc& src,const double& factor,JntArrayAcc& dest);
+        KDL_EXPORT friend void Divide(const JntArrayAcc& src,const doubleVel& factor,JntArrayAcc& dest);
+        KDL_EXPORT friend void Divide(const JntArrayAcc& src,const doubleAcc& factor,JntArrayAcc& dest);
+        KDL_EXPORT friend void SetToZero(JntArrayAcc& array);
+        KDL_EXPORT friend bool Equal(const JntArrayAcc& src1,const JntArrayAcc& src2,double eps=epsilon);
 
     };
 }
diff --git a/orocos_kdl/src/jntarrayvel.hpp b/orocos_kdl/src/jntarrayvel.hpp
index c9cf764..72cb4b1 100644
--- a/orocos_kdl/src/jntarrayvel.hpp
+++ b/orocos_kdl/src/jntarrayvel.hpp
@@ -25,11 +25,12 @@
 #include "utilities/utility.h"
 #include "jntarray.hpp"
 #include "framevel.hpp"
+#include "kdl_export.hpp"
 
 namespace KDL
 {
 
-    class JntArrayVel
+    class KDL_EXPORT JntArrayVel
     {
     public:
         JntArray q;
@@ -45,16 +46,16 @@ namespace KDL
         JntArray value()const;
         JntArray deriv()const;
 
-        friend void Add(const JntArrayVel& src1,const JntArrayVel& src2,JntArrayVel& dest);
-        friend void Add(const JntArrayVel& src1,const JntArray& src2,JntArrayVel& dest);
-        friend void Subtract(const JntArrayVel& src1,const JntArrayVel& src2,JntArrayVel& dest);
-        friend void Subtract(const JntArrayVel& src1,const JntArray& src2,JntArrayVel& dest);
-        friend void Multiply(const JntArrayVel& src,const double& factor,JntArrayVel& dest);
-        friend void Multiply(const JntArrayVel& src,const doubleVel& factor,JntArrayVel& dest);
-        friend void Divide(const JntArrayVel& src,const double& factor,JntArrayVel& dest);
-        friend void Divide(const JntArrayVel& src,const doubleVel& factor,JntArrayVel& dest);
-        friend void SetToZero(JntArrayVel& array);
-        friend bool Equal(const JntArrayVel& src1,const JntArrayVel& src2,double eps=epsilon);
+        KDL_EXPORT friend void Add(const JntArrayVel& src1,const JntArrayVel& src2,JntArrayVel& dest);
+        KDL_EXPORT friend void Add(const JntArrayVel& src1,const JntArray& src2,JntArrayVel& dest);
+        KDL_EXPORT friend void Subtract(const JntArrayVel& src1,const JntArrayVel& src2,JntArrayVel& dest);
+        KDL_EXPORT friend void Subtract(const JntArrayVel& src1,const JntArray& src2,JntArrayVel& dest);
+        KDL_EXPORT friend void Multiply(const JntArrayVel& src,const double& factor,JntArrayVel& dest);
+        KDL_EXPORT friend void Multiply(const JntArrayVel& src,const doubleVel& factor,JntArrayVel& dest);
+        KDL_EXPORT friend void Divide(const JntArrayVel& src,const double& factor,JntArrayVel& dest);
+        KDL_EXPORT friend void Divide(const JntArrayVel& src,const doubleVel& factor,JntArrayVel& dest);
+        KDL_EXPORT friend void SetToZero(JntArrayVel& array);
+        KDL_EXPORT friend bool Equal(const JntArrayVel& src1,const JntArrayVel& src2,double eps=epsilon);
 
     };
 }
diff --git a/orocos_kdl/src/jntspaceinertiamatrix.hpp b/orocos_kdl/src/jntspaceinertiamatrix.hpp
index 9376d3c..818815e 100644
--- a/orocos_kdl/src/jntspaceinertiamatrix.hpp
+++ b/orocos_kdl/src/jntspaceinertiamatrix.hpp
@@ -25,6 +25,7 @@
 #include "frames.hpp"
 #include "jacobian.hpp"
 #include "jntarray.hpp"
+#include "kdl_export.hpp"
 
 #include <Eigen/Core>
 
@@ -67,7 +68,7 @@ class MyTask : public RTT::TaskContext
 
      */	
 
-    class JntSpaceInertiaMatrix
+    class KDL_EXPORT JntSpaceInertiaMatrix
     {
     public:
         Eigen::MatrixXd data;
@@ -143,7 +144,7 @@ class MyTask : public RTT::TaskContext
          * @param src2 B
          * @param dest C
          */
-        friend void Add(const JntSpaceInertiaMatrix& src1,const JntSpaceInertiaMatrix& src2,JntSpaceInertiaMatrix& dest);
+        KDL_EXPORT friend void Add(const JntSpaceInertiaMatrix& src1,const JntSpaceInertiaMatrix& src2,JntSpaceInertiaMatrix& dest);
         /**
          * Function to subtract two joint matrix, all the arguments must
          * have the same size: A - B = C. This function is
@@ -153,7 +154,7 @@ class MyTask : public RTT::TaskContext
          * @param src2 B
          * @param dest C
          */
-        friend void Subtract(const JntSpaceInertiaMatrix& src1,const JntSpaceInertiaMatrix& src2,JntSpaceInertiaMatrix& dest);
+        KDL_EXPORT friend void Subtract(const JntSpaceInertiaMatrix& src1,const JntSpaceInertiaMatrix& src2,JntSpaceInertiaMatrix& dest);
         /**
          * Function to multiply all the array values with a scalar
          * factor: A*b=C. This function is aliasing-safe, A can be the
@@ -163,7 +164,7 @@ class MyTask : public RTT::TaskContext
          * @param factor b
          * @param dest C
          */
-        friend void Multiply(const JntSpaceInertiaMatrix& src,const double& factor,JntSpaceInertiaMatrix& dest);
+        KDL_EXPORT friend void Multiply(const JntSpaceInertiaMatrix& src,const double& factor,JntSpaceInertiaMatrix& dest);
         /**
          * Function to divide all the array values with a scalar
          * factor: A/b=C. This function is aliasing-safe, A can be the
@@ -173,7 +174,7 @@ class MyTask : public RTT::TaskContext
          * @param factor b
          * @param dest C
          */
-        friend void Divide(const JntSpaceInertiaMatrix& src,const double& factor,JntSpaceInertiaMatrix& dest);
+        KDL_EXPORT friend void Divide(const JntSpaceInertiaMatrix& src,const double& factor,JntSpaceInertiaMatrix& dest);
         /**
          * Function to multiply a KDL::Jacobian with a KDL::JntSpaceInertiaMatrix
          * to get a KDL::Twist, it should not be used to calculate the
@@ -186,13 +187,13 @@ class MyTask : public RTT::TaskContext
          * @param dest t
          * @post dest==Twist::Zero() if 0==src.rows() (ie src is empty)
          */
-        friend void Multiply(const JntSpaceInertiaMatrix& src, const JntArray& vec, JntArray& dest);
+        KDL_EXPORT friend void Multiply(const JntSpaceInertiaMatrix& src, const JntArray& vec, JntArray& dest);
         /**
          * Function to set all the values of the array to 0
          *
          * @param array
          */
-        friend void SetToZero(JntSpaceInertiaMatrix& matrix);
+        KDL_EXPORT friend void SetToZero(JntSpaceInertiaMatrix& matrix);
         /**
          * Function to check if two matrices are the same with a
          *precision of eps
@@ -203,9 +204,9 @@ class MyTask : public RTT::TaskContext
          * @return true if each element of src1 is within eps of the same
 		 * element in src2, or if both src1 and src2 have no data (ie 0==rows())
          */
-        friend bool Equal(const JntSpaceInertiaMatrix& src1,const JntSpaceInertiaMatrix& src2,double eps=epsilon);
+        KDL_EXPORT friend bool Equal(const JntSpaceInertiaMatrix& src1,const JntSpaceInertiaMatrix& src2,double eps=epsilon);
 
-        friend bool operator==(const JntSpaceInertiaMatrix& src1,const JntSpaceInertiaMatrix& src2);
+        KDL_EXPORT friend bool operator==(const JntSpaceInertiaMatrix& src1,const JntSpaceInertiaMatrix& src2);
         //friend bool operator!=(const JntSpaceInertiaMatrix& src1,const JntSpaceInertiaMatrix& src2);
         };
 
diff --git a/orocos_kdl/src/joint.hpp b/orocos_kdl/src/joint.hpp
index 4c677ec..67e2d9e 100644
--- a/orocos_kdl/src/joint.hpp
+++ b/orocos_kdl/src/joint.hpp
@@ -23,10 +23,10 @@
 #define KDL_JOINT_HPP
 
 #include "frames.hpp"
+#include "kdl_export.hpp"
 #include <string>
 #include <exception>
 
-
 namespace KDL {
 
     /**
@@ -42,7 +42,7 @@ namespace KDL {
      *
      * @ingroup KinematicFamily
      */
-    class Joint {
+    class KDL_EXPORT Joint {
     public:
         typedef enum { RotAxis,RotX,RotY,RotZ,TransAxis,TransX,TransY,TransZ,None} JointType;
         /**
